
static void  qSort (unsigned short pivotP, size_t nElem) {
    unsigned short     leftP, rightP, pivotEnd, pivotTemp, leftTemp;
    unsigned  short lNum;
    int       retval;


tailRecursion:
    if (nElem <= 2) {
        if (nElem == 2) {
            if (comp(pivotP, rightP = pivotP + 1) > 0)
                ex(pivotP, rightP);
        }
        return;
    }

    rightP = (nElem - 1) + pivotP;
    leftP  = (nElem >> 1) + pivotP;

/*  sort the pivot, left, and right elements for "median of 3" */

    if (comp (leftP, rightP) > 0)
        ex (leftP, rightP);
    if (comp (leftP, pivotP) > 0)
        ex (leftP, pivotP);
    else if (comp (pivotP, rightP) > 0)
        ex (pivotP, rightP);

    if (nElem == 3) {
        ex (pivotP, leftP);
        return;
    }

/*  now for the classic Hoare algorithm */

    leftP = pivotEnd = pivotP + 1;

    do {
        while ((retval = comp (leftP, pivotP)) <= 0) {
            if (retval == 0) {
                ex(leftP, pivotEnd);
                pivotEnd += 1;
            }
            if (leftP < rightP)
                leftP += 1;
            else
                goto qBreak;
        }

        while (leftP < rightP) {
            if ((retval = comp(pivotP, rightP)) < 0)
                rightP -= 1;
            else {
                ex (leftP, rightP);
                if (retval != 0) {
                    leftP += 1;
                    rightP -= 1;
                }
                break;
            }
        }
    }   while (leftP < rightP);

qBreak:

    if (comp(leftP, pivotP) <= 0)
        leftP = leftP + 1;

    leftTemp = leftP - 1;

    pivotTemp = pivotP;

    while ((pivotTemp < pivotEnd) && (leftTemp >= pivotEnd)) {
        ex(pivotTemp, leftTemp);
        pivotTemp += 1; leftTemp -= 1;
    }

    lNum = leftP - pivotEnd;
    nElem = (nElem + pivotP) - leftP;

    /* Sort smaller partition first to reduce stack usage */
    if (nElem < lNum) {
        qSort(leftP, nElem); nElem = lNum;
    }
    else {
        qSort(pivotP, lNum);
        pivotP = leftP;
    }

    goto tailRecursion;
}
