/* All necessary declarations */
#ifdef __WIN32__
// #define WIN32
#endif
//#define _IO_THROW 1
#include <FL/Fl.H>
#include <FL/fl_ask.H>
#include <FL/Fl_Select_Browser.H>
#include <FL/Fl_Menu.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Choice.H>
#include <FL/fl_file_chooser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_File_Dialog.H>
#include <FL/Fl_Output.H>
#include <FL/filename.H>
#ifndef __WIN32__
#include <stdlib.h>
#include <stdio.h>
#include <iomanip.h>
#include <unistd.h>
#endif
#include <FL/Fl_NSlider.H>
#include <string>
#ifdef __WIN32__
#include <Windows32/Base.h>
#include <Windows32/Defines.h>
#include <Windows32/Structures.h>
#include <winsock.h>
// #undef WIN32
#include <sys/types.h>
#ifndef errno
#include <errno.h>
#endif
typedef unsigned short  ushort;   /* System V compatibility */
typedef unsigned int  uint;   /* System V compatibility */
typedef short dev_t;

typedef long  off_t;

typedef unsigned short  uid_t;
typedef unsigned short  gid_t;
typedef int pid_t;
typedef long key_t;
typedef long ssize_t;
#endif
#include <vector>

class store_query {
public:
	string db,query; int redosled;
	store_query(string &d,string &q, int i) : db(d), query(q) , redosled(i) {}
	store_query& operator= (const store_query& one) { 
		if (&one!=this) {
			db.erase(); query.erase(); db=one.db; query=one.query; redosled=one.redosled;
		}
		return *this;
	}
};
extern string options_file_name, help_file_name, queries_file_name;
extern vector<store_query> queries;
extern char file_name[256], termin[33], enclose[33], *db,*ldb;
extern void if_disconn(void);
extern void Sinisa_File_Dialog(void);
extern void do_exit (Fl_Widget *w,void *p);
extern void get_tables(Fl_Button *w, void *p);
extern void get_get_tables(void);
extern void strip (string& s);
extern void escape_string (string& s);
extern void do_help(Fl_Button *w, void *p);
extern void call_browser (Fl_Browser *w,void *p);
extern void insert_command (Fl_Widget  *w, void *p);
extern void make_query (Fl_Widget  *w, void *p);
extern void save_save_query(const char *);
extern void database_func  (int , const char *);
extern Fl_Menu_Item *baze,komande[],*polja, *query_menus, *query_dir_menus;
extern Fl_NSlider *limit;
extern unsigned int num_of_rows;
extern int save_from, adm_ispis;
extern void get_results(Fl_Button *, void *);
extern void  do_sql(void);
extern void s_fl_message (const char *fmt,...);
extern void s_fl_alert   (const char *fmt,...);
extern void Trim(char *s);
extern int options_apply(char *,char *,char *,double ,int ,char *,char *,char *,char *,char *, int, int, int comp,double out, int ask, int mw, double ut, int f_n, const char *s_f);
extern void  options_save(char *,char *,char *,double ,int ,char *,char *,char *,char *,char *, int,  int , int comp,double out, int ask, int mw, double ut, int f_n, const char *s_f);
void do_save_file (string& s);
class options_type {
 public:	
	string username;
	string hostname;
	string port_num;
	string num_of_queries;
	string timeout;
	string q_root;
	string l_d_file;
	string defbase;
	string socketname;
	string query_file;
	string terminator;
	string enclose;
	string style_file;
	char max_width_s[13];
	int password, compress,int_timeout,int_queries,port, ask, max_width,font_number;
	double fl_timeout, update_timeout;
	options_type(const char *us,const char *ho, const char *po, const char *nu,\
							 const char *ti, int pa, int co, double fl,\
							 const char *q, const char *ldb,const char *db,const char *socket,\
							 const char *qf, const char *term,\
							 const char *enc, int as, int mw, double ut, int f_n, const char *s_f ) : username(us), hostname(ho), \
		port_num(po), num_of_queries(nu), timeout(ti), \
		q_root(q), l_d_file(ldb), defbase(db), socketname(socket), query_file(qf),\
		terminator(term), enclose(enc), style_file(s_f) , password(pa), compress(co),	ask(as), max_width(mw), font_number(f_n), fl_timeout(fl), update_timeout(ut) {
		int_timeout = atoi(timeout.c_str()); 
		int_queries = atoi(num_of_queries.c_str()); 
		port = atoi(port_num.c_str()); sprintf(max_width_s,"%d",max_width);
	}
};
extern options_type *options;
extern int connected;
extern int w1_x, w1_y, w2_x, w2_y, w3_x, w3_y, w4_x, w4_y,w5_x,w5_y;
struct var_type {
	string name,value;
	int  begin, end;
};
extern vector<var_type> vars;
extern vector<int> chosen_tables; extern vector<string> tables; extern unsigned int num_of_tables;
extern int admin_act, flush_act, admin4_act, admin5_act;
extern char *image_mysql_do_sql[]; extern string chosen_table;

