#include "bebac.h"
#include "qsort.h"
#include "komande.h"
#ifdef __WIN32__
#include <dirent.h>
#endif
#include <limits.h>
#ifndef __WIN32__
#include <dirent.h>
#define koliko 3
#else
#include <iomanip.h>
#include <mingw32/io.h>
#include <mingw32/fcntl.h>
#define koliko 1
#endif
#include <sys/stat.h>
extern "C" {
	char *intern_filename(char *,const char *); extern char *home_dir;
	char *fn_format(char *to,const char *name,const char *dsk,const char *form,int flag);
	void load_defaults(const char *conf_file, const char **groups, int *argc, char ***argv);
	void free_defaults(char **argv);
	void mysql_read_default_options(struct st_mysql_options *options,  const char *filename,const char *group);
	int strcasecmp(const char *,const char *);
	typedef struct st_typelib {	
		uint count;
		char  *name;
		char  **type_names;
	} TYPELIB;
	int find_type(char *x,TYPELIB *typelib,uint full_name);
#if defined(__GNUC__)
	typedef char pchar;
#else
	typedef int pchar;
#endif
	char *strcend(const char *,pchar);
}
#define array_elements(A) ((uint) (sizeof(A)/sizeof(A[0])))
#define FIELDS_PER_TABLE 50
#include <sys/stat.h>
static vector <string> databases,hierarchy,stringovi; vector<string> tables;
vector <int> chosen_tables; vector <store_query> queries;
#include <sqlplus.hh>
#ifndef _WIN32
#include <fstream.h>
#endif
Connection *con;  volatile enum ios::open_mode how_to_open = ios::trunc;
options_type *options; string real_sql, chosen_table; static string ddd;
int save_from = 0; unsigned int  num_of_rows, num_of_tables; static  int main_x=20, main_y=20;
int w1_x = 0, w1_y = 0, w2_x = 0, w2_y = 0, w3_x = 0, w3_y = 0, w4_x = 0, w4_y = 0, w5_x=0, w5_y=0, w8_x=0, w8_y=0, w7_x=0, w7_y=0;
Fl_Menu_Item *baze=(Fl_Menu_Item*)0,*query_menus=(Fl_Menu_Item *)0,*polja=(Fl_Menu_Item*)0;
extern Fl_Menu_Button *fie; extern int is_it_in_string(string &,int);
int admin_act = 0, flush_act = 0, admin4_act = 0, admin5_act = 0, server_version=0;
enum result_options {TO_SCREEN,TO_FILE,TO_COUNT};
extern void do_splash(void); extern Fl_Window *splash; extern void editing_stuff (const char *);
string options_file_name, help_file_name, queries_file_name,s_info,c_info;
char file_name[256] = "", termin[33] = ",", enclose[33] = "\"", *db = "mysql", *pass = 0, *ldb = "";
int connected = 0, where_in_queries = INT_MAX;
static char *default_options[]={"help_file","client_file","queries_file","history_length","database", "queries_root","last_database_file", NULL };
static TYPELIB option_types={array_elements(default_options)-1,"options",default_options};

static void client_read_default_options(char *help_file,char *client_file,char *queries_file,char *database,int *hist_len,char *queries_root,char *last_database_file )
{
  int argc;
  char *argv_buff[1],*groups[3],**argv ;
  argc=1; argv=argv_buff; argv_buff[0]= (char*) "client";
  groups[0]= (char*) "client_fltk"; groups[1]= 0;
	load_defaults("my", (const char **)groups, &argc, &argv);
  if (argc != 1)				/* If some default option */
  {
    char **option=argv;
    while (*++option)
    {
      if (option[0][0] == '-' && option[0][1] == '-')
      {
	char *end=strcend(*option,'=');
	char *opt_arg=0;
	if (*end)
	{
	  opt_arg=end+1;
	  *end=0;				/* Remove '=' */
	}
	switch (find_type(*option+2,&option_types,2)) {
	case 1:				/* help_file */
	  if (opt_arg)
	    strcpy (help_file,opt_arg);
	  break;
	case 2:				/* client_file */
	  if (opt_arg)
			strcpy (client_file,opt_arg);
	  break;
	case 3:				/* queries_file */
	  if (opt_arg)
			strcpy (queries_file,opt_arg);
	  break;
	case 4:				/* how many queries in a file / listbox*/
	  if (opt_arg)
			*hist_len=atoi(opt_arg);
	  break;
	case 5:				/* database  */
	  if (opt_arg)
			strcpy (database,opt_arg);
	  break;
	case 6:				/* queries_root  */
	  if (opt_arg)
			strcpy (queries_root,opt_arg);
	  break;
	case 7:				/* last_database_file  */
	  if (opt_arg)
			strcpy (last_database_file,opt_arg);
	  break;
	default: break;
	}
      }
    }
  }
  free_defaults(argv);
}

static void run_query (Fl_Widget  *w, void *p) {  
  Fl_Menu_*mw = (Fl_Menu_*)w;
  const Fl_Menu_Item *m = mw->mvalue(); if (!m) return;
  sql_command->cut(0,sql_command->size()); sql_command->insert(hierarchy[int(p)-1].c_str()); sql_command->position(0); sql_command->mark(0);
}

static void recurse (string &s, Fl_Menu_Item **ord_menu) {
  DIR *dir; struct dirent *de; struct stat sb; 
	int total_menu_length = 0, i = 0;
  dir = opendir ( s.c_str());
  if ( dir) {
		while ( (de = readdir ( dir )) != NULL ) {
      string path(s);  if (path[path.length()-1] != '/') path += (string)"/";
			if (((string)de->d_name == (string)".") || ((string)de->d_name == (string)"..")) continue;
			path += (string)de->d_name;
			if ( !stat ( path.c_str(), &sb ) ) {
				if (sb.st_mode & S_IRUSR){
					if ((filename_isdir(path.c_str()) && ( sb.st_mode & S_IXUSR)) || (!strcmp(filename_ext(path.c_str()),".sql")))
						total_menu_length++; 
				}
			}
		}
		closedir(dir);
		if (!total_menu_length) return;
		*ord_menu = new Fl_Menu_Item[total_menu_length + 1]; memset(*ord_menu,0,(total_menu_length + 1)*sizeof(Fl_Menu_Item));
		dir = opendir ( s.c_str());
		while ( (de = readdir ( dir )) != NULL ) {
			string path(s); if (path[path.length()-1] != '/') path += (string)"/";
			if (((string)de->d_name == (string)".") || ((string)de->d_name == (string)"..")) continue;
			path+=de->d_name; 
			if ( !stat ( path.c_str(), &sb ) ) {
				if (filename_isdir(path.c_str()) && ( sb.st_mode & S_IXUSR)) {
					Fl_Menu_Item *xx=(Fl_Menu_Item *)0;
					recurse(path,&xx);
					stringovi.insert(stringovi.end(),path);
					if (!xx) {
						xx = new Fl_Menu_Item[2]; memset (xx,0,sizeof(Fl_Menu_Item)*2); xx[0].text = "empty"; xx[1].text=NULL;
					}
					stringovi.insert(stringovi.end(),(string) de->d_name); (*ord_menu)[i].text =stringovi[stringovi.size()-1].c_str(); (*ord_menu)[i].flags =  FL_MENU_DIVIDER | FL_SUBMENU_POINTER; (*ord_menu)[i].user_data_=(void *)xx; i++;
				}	else if ((sb.st_mode & S_IRUSR) && (!strcmp(filename_ext(path.c_str()),".sql"))) {
#ifdef _WIN32
        FILE *fd = fopen(path.c_str(),"r");
        if (fd) {
          string query = (string)"", in; char xx[4097];
          while (fgets(xx,4096,fd)) {
            in = (string)xx; query += in + (string)"\n";
          }
          strip(query);
          hierarchy.insert(hierarchy.end(),query);
          stringovi.insert(stringovi.end(),(string) de->d_name); 
          (*ord_menu)[i].text =stringovi[stringovi.size()-1].c_str(); (*ord_menu)[i].flags =  0; 
          (*ord_menu)[i].user_data_=(void *)hierarchy.size(); (*ord_menu)[i].callback((Fl_Callback*)run_query); i++;
          fclose (fd);
        }
#else
					ifstream In (path.c_str());
					if ((In.rdbuf())->is_open()) {
						string query = (string)"", in;
						while(getline(In,in)) query += in + (string)"\n"; strip(query);
						hierarchy.insert(hierarchy.end(),query);
						stringovi.insert(stringovi.end(),(string) de->d_name); 
						(*ord_menu)[i].text =stringovi[stringovi.size()-1].c_str(); (*ord_menu)[i].flags =  0; 
						(*ord_menu)[i].user_data_=(void *)hierarchy.size(); (*ord_menu)[i].callback((Fl_Callback*)run_query); i++;
					}
#endif          
				}
			}
		}
		closedir ( dir ); i++;
	}
}

static int Fcmp_q (unsigned short int s1, unsigned short int s2) {
	if (queries[s1].db == queries[s2].db) return queries[s1].redosled - queries[s2].redosled;
	if (queries[s1].db > queries[s2].db) return 1;
	return -1;
}
static int Fcmp_qq (unsigned short int s1, unsigned short int s2) {
	return queries[s1].redosled - queries[s2].redosled;
}
static void Exchange_q ( unsigned short x, unsigned short y) {
   store_query tmp = queries[x]; queries[x] = queries[y]; queries[y] = tmp;
}

static void pomocna_polja(void) {
	if (polja) {
		for(int i=0;polja[i].text;i++) {if (polja[i].text) free((char *)(polja[i].text));}  free(polja); polja = (Fl_Menu_Item *)0;
	}
	polja = (Fl_Menu_Item *) malloc(sizeof(Fl_Menu_Item)*2); memset(polja,0,sizeof(Fl_Menu_Item)*2); polja[0].text=strdup("None"); if (fie) fie->menu(polja);
}

static const char *konstante[] = {
"user", "host","port","num_of_queries","timeout","defbase","socket","queries_file","queries_root",					
"last_database_file","terminator","enclose","password","compress","ask","max_width","update_timeout","font_used","style_file"};

enum options_file_const {USER=0,HOST,PORT,NUM_OF_QUERIES,TIMEOUT,DEFBASE,SOCKETT,QUERIES_FILE,QUERIES_ROOT,\
												 LAST_DATABASE_FILE,TERMINATOR,ENCLOSE,PASSWORD,COMPRESS,ASK,MAX_WIDTH,UPDATE_TIMEOUT,FONT_USED,STYLE_FILE,ERRORRR};

static void init_code (void) { 
	char to[512], from[256], hhelp[256], client[256], querys[256],queries_root[256],last_database_file[256]; 
	static char bases[256]; int histories = 0;
	static char home_buff[512]; struct st_mysql_options opt;
	memset (&opt,0,sizeof(struct st_mysql_options)); queries_root[0] = last_database_file[0] =  bases[0] = querys[0] = to[0] = from[0] = hhelp[0] = client[0] = '\0';
	if ((home_dir=getenv("HOME")) != 0)
		home_dir=intern_filename(home_buff,home_dir);
	else home_dir="";
#ifdef _WIN32
	mysql_read_default_options(&opt,"c:\\my.cnf","client");
#else	
	mysql_read_default_options(&opt,"my","");
#endif
	if (opt.user || opt.host || opt.connect_timeout || opt.port || opt.password || opt.compress) s_fl_message("Found  entries for any client at regular MySQL config file");
	client_read_default_options(hhelp,client,querys,bases,&histories,queries_root,last_database_file);
	if (hhelp[0] || client [0] || querys [0] || bases[0] || histories || queries_root[0] || last_database_file[0]) s_fl_message("Found entries for this client at regular MySQL config file");
	if (querys[0]) strcpy (from,querys); else strcpy(from,"~/.mysql_history");
	strcpy(to,fn_format(to,from,"","",4)); queries_file_name = (string)to;
	if (hhelp[0]) {
		strcpy (from,hhelp); strcpy(to,fn_format(to,from,"","",4)); help_file_name=(string)to;
		if (access(to,F_OK))
      help_file_name = (string)"";
	}
  else help_file_name = (string)""; 
	if (client[0]) {
		char buff[512];
		strcpy (from,client); 
		strcpy(to,fn_format(buff,from,"","",4)); 
		options_file_name=(string)to;
	}
  else 
#ifdef __WIN32__
		options_file_name = "c:\\mysql.opt";
#else
		options_file_name = (string)home_dir + (string)"/.mysql.options";
#endif
  options = new options_type ((opt.user) ? opt.user : (const char *)"root",(opt.host) ? opt.host :(const char *)"localhost",(const char *)"3306",(const char *)"100",(const char *)"60",1,0,60.0,(const char *)"",(const char *)"mysql",(const char *)"",(const char *)"",(const char *)queries_file_name.c_str(),(const char *)",",(const char *)"\'",1,50,10.0,-1,(const char *)"");
	if (opt.port) {options->port = opt.port; char xx[33]; sprintf(xx,"%d",options->port); options->port_num = (string) xx;}
	if (histories) {options->int_queries = histories; char xx[33]; sprintf(xx,"%d",histories); options->num_of_queries = (string) xx;}
	if (opt.connect_timeout) {options->int_timeout  = opt.connect_timeout; char xx[33]; sprintf(xx,"%d",options->int_timeout); options->timeout = (string) xx; options->fl_timeout=double(options->int_timeout);}
	if (opt.compress) options->compress = opt.compress; if (opt.password) {options->password = 1; pass=opt.password;}
	if (bases[0]) db = bases;
	if (queries_root[0]) {
		strcpy (from,queries_root); strcpy(to,fn_format(to,from,"","",4)); options->q_root=(string)to;
	}
	if (last_database_file[0]) {
		strcpy (from,last_database_file); strcpy(to,fn_format(to,from,"","",4)); options->l_d_file=(string)to;
	}
  else options->l_d_file = (string)""; 
	if (options_file_name.length()) {
#ifdef _WIN32
  char buffer [2049];
  FILE *fd = fopen(options_file_name.c_str(),"r");
  if (!fd)
#else
		ifstream In (options_file_name.c_str());
		if (!In.rdbuf()->is_open())
#endif    
			s_fl_alert ("You have not created client  options file, which is highly recommended");
		else {
			s_fl_message ("Options file found and readable at path %s",options_file_name.c_str());
			try {
				string password(""), compress(""),xx;
#ifdef _WIN32
        while (fgets(buffer,2048,fd)) {
          xx = (string)buffer; strip(xx); if ((xx.find("//") == 0) || (xx.find("#") == 0) || (xx.find(";") == 0) || (xx.find("=") == -1)) continue;
#else
				while (!In.eof()) {
					getline (In,xx); strip(xx); if ((xx.find("//") == 0) || (xx.find("#") == 0) || (xx.find(";") == 0) || (xx.find("=") == -1)) continue;
#endif          
					unsigned int ii, where = xx.find("="); string variable(xx,0,where); strip(variable); 
#ifdef _WIN32          
          xx.assign(xx,where+1,xx.length()-where-2); 
#else
          xx.assign(xx,where+1,xx.length()-where-1); 
#endif
          strip(xx); if (!variable.length() || !xx.length()) continue; for (ii=0;ii<variable.length();variable[ii]=tolower(variable[ii]),ii++); enum options_file_const switch_var=USER;
					for (ii=0;ii<array_elements(konstante);ii++) if (variable==(string)konstante[ii]) break; switch_var=(enum options_file_const)ii;
					if (switch_var==ERRORRR) continue;
					switch (switch_var) {
					case USER: options->username = xx; break;
					case HOST: options->hostname = xx; break;
					case PORT: options->port_num = xx; break;
					case NUM_OF_QUERIES: options->num_of_queries = xx; break;
					case TIMEOUT: options->timeout = xx; break;
					case DEFBASE: options->defbase = xx; break;
					case SOCKETT: options->socketname = xx; break;
					case QUERIES_FILE: strcpy(to,fn_format(to,xx.c_str(),"","",4)); options->query_file = (string)to; break;
					case QUERIES_ROOT: strcpy(to,fn_format(to,xx.c_str(),"","",4)); options->q_root = (string)to; break;
					case LAST_DATABASE_FILE: strcpy(to,fn_format(to,xx.c_str(),"","",4));  options->l_d_file = (string)to; break;
					case TERMINATOR: options->terminator = xx; break;
					case ENCLOSE: options->enclose = xx; break;
					case PASSWORD: password = xx; break;
					case COMPRESS: compress = xx; break;
					case ASK: options->ask = atoi(xx.c_str()); break;
					case MAX_WIDTH: strcpy(options->max_width_s,xx.c_str()); options->max_width=atoi(options->max_width_s); break;
					case UPDATE_TIMEOUT: options->update_timeout = atof(xx.c_str()); break;
					case FONT_USED: {options->font_number=atoi(xx.c_str()); if (!xx.length()) options->font_number=-1; int kkk = Fl::set_fonts("*"); if (options->font_number == -1 || options->font_number > kkk) options->font_number=-1; break;}
					case STYLE_FILE: options->style_file=xx; break; 
					default: exit (111); // should NEVER happen !!!!!!!!!!!!!!!!!
					}
				}
				if (!options->username.length() && opt.user)  options->username=(string) opt.user;	if (!options->hostname.length() && opt.host)  options->hostname=(string) opt.host;
				if (!options->num_of_queries.length()) options->num_of_queries=20; if (!options->timeout.length())options->timeout=60;
				if (options->defbase.length()) db = (char *)options->defbase.c_str(); else options->defbase = (string)db; ldb = db;
				if (!options->socketname.length() && opt.unix_socket) 
					options->socketname=opt.unix_socket;
				if (password.length()) options->password = atoi(password.c_str());  if (compress.length()) options->compress = atoi(compress.c_str());
				options->int_timeout = atoi(options->timeout.c_str()); options->fl_timeout = (double) options->int_timeout;
				options->int_queries = atoi(options->num_of_queries.c_str());	options->port = atoi(options->port_num.c_str());
			} catch (...) {
				s_fl_alert ("Your options file %s is damaged !!!",options_file_name.c_str()); delete options; unlink (options_file_name.c_str());
				options = new options_type ((opt.user) ? opt.user : (const char *)"root",(opt.host) ? opt.host :(const char *)"localhost",(const char *)"3306",(const char *)"100",(const char *)"60",1,0,60.0,(const char *)"",(const char *)"mysql",(const char *)"",(const char *)"",(const char *)"~/.mysql_history",(const char *)",",(const char *)"\'",1,50,10.0,0,(const char *)0);
			}
#ifdef _WIN32
      fclose(fd);
#endif
		}
	}
	strcpy(to,fn_format(to,options->query_file.c_str(),"","",4)); options->query_file = (string)to;
				strcpy(to,fn_format(to,options->q_root.c_str(),"","",4)); options->q_root = (string)to;
				strcpy(to,fn_format(to,options->l_d_file.c_str(),"","",4));  options->l_d_file = (string)to;
				if (options->query_file.length()) queries_file_name = options->query_file; else options->query_file=queries_file_name;
	if (access(options->q_root.c_str(),F_OK)) {
#ifdef __WIN32__
		if (mkdir (options->q_root.c_str()))
#else
    if (mkdir (options->q_root.c_str(),0777))
#endif
			options->q_root = (string)"";
	}
	if (access(options->q_root.c_str(),R_OK|W_OK|X_OK)) {
		if(chmod (options->q_root.c_str(),0777)) options->q_root = (string)"";
	}
	else {
		s_fl_message ("Hierarchy root dir %s found as readable and scannable",options->q_root.c_str());
		recurse (options->q_root,&query_menus);
	}
	baze = (Fl_Menu_Item *)malloc(sizeof(Fl_Menu_Item)*2); memset(baze,0,sizeof(Fl_Menu_Item)*2); baze[0].text = "No connection"; pomocna_polja();
	if (options->l_d_file.length()) {
#ifdef _WIN32
  FILE *fd = fopen(options->l_d_file.c_str(),"r");
  if (fd) {
    char buffer[512], *s, *z; string dd; int len;
    s_fl_message ("You have saved your last database connected in %s !",options->l_d_file.c_str());    
    if ((len = fread(buffer,1,512,fd))>0) {
      s = strchr(buffer,';');
      if (s) {
        *s=0; s++; ddd=(string)buffer; strip(ddd); ldb = (char *)ddd.c_str(); db = ldb; z = s;
        if (len > s-buffer) {
          s = strchr (z,';'); 
          if (s) {*s=0;s++; dd=(string)z; strip(dd); main_x = atoi(dd.c_str()); z = s;}
          s = strchr (z,';'); 
          if (s) {*s=0; dd=(string)z; strip(dd); main_y = atoi(dd.c_str());}
        }
      }
    }
    fclose(fd);
  }
  else {
    s_fl_alert ("You have not yet saved any last database connected in %s !",options->l_d_file.c_str()); ddd=(string)"mysql"; ldb=(char *)ddd.c_str(); if (!db) db=ldb;
  }
#else
		ifstream Innn (options->l_d_file.c_str());  string dd;
		if (!(Innn.rdbuf())->is_open()) {
			s_fl_alert ("You have not yet saved any last database connected in %s !",options->l_d_file.c_str()); ddd=(string)"mysql"; ldb=(char *)ddd.c_str(); if (!db) db=ldb;
		} else {
			s_fl_message ("You have saved your last database connected in %s !",options->l_d_file.c_str());
			try {
				getline(Innn,ddd,';'); strip(ddd); ldb = (char *)ddd.c_str(); db = ldb;
				getline(Innn,dd,';'); strip(dd); main_x = atoi(dd.c_str());
				getline(Innn,dd,';'); strip(dd); main_y = atoi(dd.c_str());
			} catch (...) {
				s_fl_alert ("Your last db file %s is damaged !!!",options->l_d_file.c_str()); 
			}
		}
#endif    
	} else {if (!ldb) {ddd=(string)"mysql"; ldb=(char *)ddd.c_str(); if (!db) db=ldb;} else if (!db) {db=ldb; s_fl_alert ("You have not set last nor default database!");}}
	if (options->update_timeout < 5.0) 	options->update_timeout = 5.0;
	if (queries_file_name.length()) {
#ifdef _WIN32
  FILE *fd = fopen(queries_file_name.c_str(),"r"); string query,ddd; queries.clear(); char buffer [4097];
  if (!fd)
#else
		ifstream Inn (queries_file_name.c_str()); string query,ddd; queries.clear();
		if (!(Inn.rdbuf())->is_open())
#endif    
			s_fl_message ("You have not yet saved any queries in your history file %s !",queries_file_name.c_str());
		else {
			s_fl_message ("You have saved queries in your history file %s !",queries_file_name.c_str());
			try {
#ifdef _WIN32
        while (fgets(buffer,4096,fd)) {
          query = (string)buffer; query.erase(query.length() - 1,-1);
#else
				while(getline(Inn,query)) {
#endif          
					if (query.length() < 5) continue; strip(query);
					if (query[query.length() - 1] == ';') { 
						query.erase(query.length() - 1,-1); int ii=query.find(";");
						while ((ii != -1) && is_it_in_string(query,ii-1)) ii = query.find(";",++ii);
//						if (ii==-1) ddd=(db) ? (string)db : ((ldb) ? (string)ldb : (string)""); 
						if (ii==-1) ddd=(string)"";
						else {
							int jj=query.find(" "); 
							if (jj==-1) /*ddd=(db) ? (string)db : ((ldb) ? (string)ldb :(string)"");*/ ddd=(string)""; else ddd.assign(query,jj,ii-jj);
							query.erase(0,ii+1); strip(ddd);
						}
						strip(ddd); strip(query); if (!ddd.length()) ddd = (string)"mysql";
						if (query.length()) {
							store_query st(ddd,query,queries.size()); queries.insert(queries.end(),st);
						}
					}
					if (queries.size()== (unsigned int)options->int_queries) break;
				}
			} catch (...) {
				s_fl_alert ("Your history file %s is damaged !!!",queries_file_name.c_str()); return;
			}
#ifdef _WIN32
      fclose (fd);
#endif      
			qSortHelp (0, (size_t) queries.size(), Fcmp_q, Exchange_q);
		}
	}
	return;
}

static int Fcmp (unsigned short int s1, unsigned short int s2) {
	if (tables[s1] == tables[s2]) return 0;
	if (tables[s1] > tables[s2]) return 1;
	return -1;
}

static void Exchange ( unsigned short x, unsigned short y) {
  string tmp = tables[x]; tables[x] = tables[y]; tables[y] = tmp;
}

void if_disconn (void) { 
	c_info=s_info=(string)"Unknown";
  if (baze) free(baze); baze =  (Fl_Menu_Item *)malloc(sizeof( Fl_Menu_Item)*2);  memset(baze,0,sizeof(Fl_Menu_Item)*2);  baze[0].text = "No connection"; choice_db->menu(baze); choice_db->redraw(); pomocna_polja();
	choice_db->deactivate(); down_group->deactivate(); result_group->deactivate(); manage3->deactivate(); manage4->deactivate();
	manage1->activate();manage2->deactivate(); commands->deactivate(); hier->deactivate();
  b_connect->clear(); query_browser->clear(); down_group->deactivate(); if (ldb) {ddd=(string)ldb; ldb=(char*)ddd.c_str();}
}

static void if_conn (void) {
  unsigned int j = 0, counter = 0;  c_info=con->clinet_info(); s_info=con->server_info();
  try {
		Query query = con->query(); if (ldb) {ddd=(string)ldb; ldb=(char*)ddd.c_str();}
    query << "show databases";
    Result res = query.store(); commands->activate();
		Result::iterator i; free(baze); baze = (Fl_Menu_Item *) malloc(sizeof(Fl_Menu_Item) *(res.size()+1));  memset(baze,0,sizeof(Fl_Menu_Item)*(res.size()+1));
		databases.clear(); databases.clear(); 
		for (i = res.begin(); i != res.end(); i++) {
			Row row = *i;
			string xx(row[0]); strip(xx);
			if (xx.length()) databases.insert(databases.end(),xx); 
		}
		s_fl_message("");
  } catch (BadQuery er) {
    s_fl_alert (er.error.c_str()); s_fl_alert("\n"); connected = 0; if_disconn();
    if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
      con->close(); sql_command->cut(0,sql_command->size());
    }
    return;
  }
  try {
		Query query = con->query();
    query << "show status";
    Result res = query.store();
		admin_act = 1; commands->activate(); admin->activate();  admin->activate();
		char xx[4], *old_c = (char *) s_info.c_str(), *new_c; int ukupno =0;
		new_c=strchr(old_c,'.'); memcpy(xx,old_c,new_c-old_c); xx[new_c-old_c]=0; new_c++; old_c = new_c;
		ukupno += 10000 * atoi(xx);
		new_c=strchr(old_c,'.'); memcpy(xx,old_c,new_c-old_c); xx[new_c-old_c]=0; new_c++; old_c = new_c;
		ukupno += 100 * atoi(xx);
		ukupno += atoi(old_c);
		if (ukupno < 32200)  flush_act = 0; else {flush_act=1; flush->activate();}
		if (ukupno < 32211) admin4_act = 0; else {admin4_act=1; admin4->activate();}
		if (ukupno < 32211) admin5_act = 0; else {admin5_act=1; admin5->activate();}
		server_version = ukupno;
  } catch (BadQuery er) {
    if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
      con->close(); sql_command->cut(0,sql_command->size()); if_disconn(); connected=0;
    }
		admin_act = 0;
  }
	for (j=0;j<databases.size();j++) 
		baze[j].text = databases[j].c_str(); 
	if (ldb) db = ldb; j = 0; choice_db->menu(baze);
	if ((databases.size() > 1) && db) {
		for (j=0;j<databases.size();j++) {
			if (!strcasecmp(databases[j].c_str(),db))
				break;
		}
		if (j<databases.size()) {
			Fl::focus(choice_db); string str_(databases[j]);
			choice_db->value(j); choice_db->label(str_.c_str()); choice_db->redraw();
			Fl::focus(sql_command); 
		} else j = 0;
	} else j = 0;
	try {
		ldb=0; tables.clear();   chosen_tables.clear();con->select_db(databases[j]);
		Query query = con->query(); Result::iterator i; Row row;
		query << "show tables"; Result  res = query.store();
		manage1->deactivate(); ;manage2->activate(); commands->activate();
		for (i = res.begin(); i != res.end(); i++) {
			row = *i; string xx(row[0]);
			tables.insert(tables.end(),xx);
		}
		qSortHelp (0, (size_t) tables.size(), Fcmp, Exchange); 	
		ldb = (char *)databases[j].c_str(); c_info=con->clinet_info(); s_info=con->server_info();
		b_connect->set();    down_group->activate();  query_browser->activate();
		if (databases.size()) choice_db->activate();  choice_db->redraw(); 
		; if (query_menus) hier->activate();
		manage3->activate(); manage4->activate();
		down_group->activate(); result_group->activate();
		s_fl_message("\nFound %d tables",tables.size());
	} catch (BadQuery er) {
		s_fl_alert (er.error.c_str());  s_fl_alert("\n"); s_fl_alert("There are corrupt tables\n or no tables in your database\n or you do not have any rights in  database %s\n",databases[j].c_str());
		sql_command->cut(0,sql_command->size()); con->close(); connected = 0; if_disconn(); ldb = 0;
		return;
	}
	num_of_tables = tables.size(); pomocna_polja(); qSortHelp (0, (size_t) queries.size(), Fcmp_q, Exchange_q);
	query_browser->clear(); for(counter=0;counter<queries.size() && queries[counter].db != (string)ldb;counter++) ; 
	for (;counter<queries.size() && queries[counter].db == (string)ldb;query_browser->add(queries[counter].query.c_str()),counter++);
}

int options_apply(char *user,char *host,char *port,double queries,int passw,char *defbase,char *socketname,char *query_file,char *q_root,char *ldb, int terminator, int enclose, int comp,double out,int ask, int mw, double ut, int f_n, const  char *s_f) { 
	char *ttt[] = {"\t",",","^"," ","@","#","$","%","&"}; char to[256]; Trim (user);
	if (!fontify->text(f_n) || !strcmp(fontify->text(f_n),"None")) f_n=-1;
  if (strlen(user) > 60) {s_fl_alert ("User name %s is  too long!!\n",user); return 1;}	
  Trim (host);
  if (strlen(host) > 60) {s_fl_alert ("Host name %s is  too long!!",user); return 1;}		
  Trim (port); int i = atoi(port);
//  if (i < 1000) {s_fl_alert ("Port value %d is bad !!",i); return 1;}
  if (i < 0) {s_fl_alert ("Port value %d is bad !!",i); return 1;}
  i = int(queries);
  if ((i < 10) || (i > 500)) {s_fl_alert ("Value given (%d) for number of queries is bad !!",i); return 1;}
  if ((out < 1.0) || (out > 2000.0)) {s_fl_alert ("Value given for connection timeout is bad !!"); return 1;}
	Trim(defbase); Trim(socketname); Trim(query_file); Trim(q_root); Trim(ldb);
	options->defbase=(string)defbase; options->socketname=(string)socketname; options->query_file=(string)query_file;
	options->q_root=(string)q_root; options->l_d_file=(string)ldb; options->terminator=(string)ttt[terminator]; options->enclose=(enclose == 1) ? (string)"\"" :((enclose==2) ? (string) "\'" : (string) "");
	strcpy(to,fn_format(to,options->query_file.c_str(),"","",4)); options->query_file = (string)to;
	strcpy(to,fn_format(to,options->q_root.c_str(),"","",4)); options->q_root = (string)to;
	strcpy(to,fn_format(to,options->l_d_file.c_str(),"","",4));  options->l_d_file = (string)to;
	if (options->defbase.length()) db = (char *)options->defbase.c_str();
	if (options->query_file.length()) queries_file_name=options->query_file;
  if (user[0]) options->username = (string)user;  if (host[0]) options->hostname = (string)host;
  if (port[0]) {options->port_num = (string)port; options->port = atoi(port);}
	char buff[13]; sprintf(buff,"%8.0f",queries);
  options->num_of_queries=buff;  options->int_queries=int(queries);
  options->fl_timeout = out;  options->int_timeout=int(options->fl_timeout);
  options->password = passw; options->compress = comp; options->update_timeout=ut; if (options->update_timeout < 5.0) options->update_timeout=5.0;
  options_window->hide(); delete options_window; options_window=(Fl_Window *)0; pass = NULL; options->ask=ask; options->max_width=mw; sprintf(options->max_width_s,"%d",options->max_width);
	options->font_number = (f_n > 0) ? f_n - 1 : -1; options->style_file=(string)s_f;
	int kkk = Fl::set_fonts("*"); if (options->font_number == -1 || options->font_number > kkk) options->font_number=-1;
  return 0;
}

void  options_save(char *user,char *host,char *port,double queries,int passw,char *defbase,char *socketname,char *query_file,char *q_root,char *ldb, int terminator, int enclose, int comp,double out,int ask, int mw, double ut, int f_n, const  char *s_f) { 
	if (!fontify->text(f_n) || !strcmp(fontify->text(f_n),"None")) f_n=0;
	if (options_apply(user,host,port, queries, passw,defbase,socketname,query_file,q_root,ldb,terminator,enclose,comp,out,ask,mw,ut,f_n,s_f)) return; 
#ifdef _WIN32
  FILE *fd = fopen(options_file_name.c_str(),"w+"); enum options_file_const switch_var=USER;
  if (!fd)
#else
	ofstream Out(options_file_name.c_str(),ios::out | ios::trunc); enum options_file_const switch_var=USER;
  if (!(Out.rdbuf())->is_open())
#endif  
    s_fl_alert ("You have no rights to open options file %s for writing !!",options_file_name.c_str());
  else {
    try {
#ifdef _WIN32      
      (void) fprintf(fd,"#  Options file generated by MySQL client\n\n");
#else
			Out << "#  Options file generated by MySQL client" << endl << endl;
#endif      
			for (unsigned int ii=0;ii<array_elements(konstante);ii++) {
				switch_var=(enum options_file_const)ii;
				if (switch_var==ERRORRR) break; 
#ifdef _WIN32
        (void) fprintf(fd,"%s=",konstante[ii]);
#else
        Out << konstante[ii] << "=" << "";
#endif        
				switch (switch_var) {
#ifdef _WIN32
        case USER:  if (options->username.length()) fprintf(fd,options->username.c_str()); fprintf(fd,"\n"); break;
        case HOST: if (options->hostname.length()) fprintf(fd,options->hostname.c_str()); fprintf(fd,"\n"); break;
        case PORT: if (options->port_num.length()) fprintf(fd,options->port_num.c_str()); fprintf(fd,"\n"); break;
        case NUM_OF_QUERIES: if (options->int_queries) fprintf (fd,"%d",options->int_queries); fprintf(fd,"\n"); break;
        case TIMEOUT:  if (options->int_timeout) fprintf (fd,"%d",options->int_timeout); fprintf(fd,"\n"); break;
        case DEFBASE:  if (options->defbase.length()) fprintf (fd,options->defbase.c_str()); fprintf(fd,"\n"); break;
        case SOCKETT:   strip(options->socketname); if (options->socketname.length()) fprintf(fd,options->socketname.c_str()); fprintf(fd,"\n"); break;
        case QUERIES_FILE:   if (options->query_file.length()) fprintf(fd,options->query_file.c_str()); fprintf(fd,"\n"); break;
        case QUERIES_ROOT:   if (options->q_root.length())  fprintf (fd,options->q_root.c_str()); fprintf(fd,"\n"); break;
        case LAST_DATABASE_FILE:   if (options->l_d_file.length())  fprintf(fd,options->l_d_file.c_str()); fprintf(fd,"\n"); break;
        case TERMINATOR: fprintf(fd,options->terminator.c_str()); fprintf(fd,"\n"); break;
        case ENCLOSE:   if (options->enclose.length()) fprintf (fd,options->enclose.c_str()); fprintf(fd,"\n"); break;
        case PASSWORD:  fprintf (fd,"%d",options->password); fprintf(fd,"\n"); break;
        case COMPRESS:  fprintf (fd,"%d",options->compress); fprintf(fd,"\n"); break;
        case ASK:   fprintf (fd,"%d",options->ask); fprintf(fd,"\n"); break;
        case MAX_WIDTH:   if (options->max_width) fprintf(fd,"%d",options->max_width); fprintf(fd,"\n"); break;
        case UPDATE_TIMEOUT:  fprintf(fd,"%9.2f",options->update_timeout); fprintf(fd,"\n"); break;					
				case	FONT_USED:  if (options->font_number != -1) fprintf(fd,"%d",options->font_number); fprintf(fd,"\n"); break;
				case  STYLE_FILE: fprintf(fd,"%s\n",options->style_file.c_str()); break;
#else
				case USER:  if (options->username.length()) {Out << options->username << endl ;} else Out << endl; break;
				case HOST: if (options->hostname.length()) {Out << options->hostname << endl;} else Out << endl; break;
				case PORT: if (options->port_num.length()) {Out << options->port_num << endl;} else Out << endl; break;
				case NUM_OF_QUERIES: if (options->int_queries) {Out << options->int_queries << endl;} else Out << endl; break;
				case TIMEOUT:  if (options->int_timeout) {Out << options->int_timeout << endl;} else Out << endl; break;
				case DEFBASE:  if (options->defbase.length()) {Out << options->defbase << endl;} else Out << endl; break;
				case SOCKETT:   strip(options->socketname); if (options->socketname.length()) {Out << options->socketname << endl;} else Out << endl; break;
				case QUERIES_FILE:   if (options->query_file.length()) {Out << options->query_file << endl;} else Out << endl; break;
				case QUERIES_ROOT:   if (options->q_root.length()) {Out << options->q_root << endl;} else Out << endl; break;
				case LAST_DATABASE_FILE:   if (options->l_d_file.length()) {Out << options->l_d_file << endl;} else Out << endl; break;
				case TERMINATOR: Out << options->terminator << endl; break;
				case ENCLOSE:   if (options->enclose.length()) {Out << options->enclose << endl;} else Out << endl; break;
				case PASSWORD:  Out << options->password << endl; break;
				case COMPRESS:  Out << options->compress << endl; break;
				case ASK:   Out << options->ask << endl; break;
				case MAX_WIDTH:   if (options->max_width) {Out << options->max_width << endl;} else Out << endl; break;
				case UPDATE_TIMEOUT: Out << (int)options->update_timeout << endl; break;
				case	FONT_USED:   if (options->font_number != -1)  Out << (int)options->font_number << endl; else Out << endl;  break;
				case  STYLE_FILE: Out << options->style_file  << endl; break;
#endif        
				default: exit (111); // should NEVER happen !!!!!!!!!!!!!!!!!
				}
			}
#ifndef _WIN32      
			Out << ends;
#endif      
    } catch (...) {
      s_fl_alert ("Your options file %s is damaged !!!",options_file_name.c_str()); unlink (options_file_name.c_str());
    }
#ifdef _WIN32
    fclose(fd);
#endif
  }
}

void do_dis_connect (Fl_Light_Button  *w, void *p) {  
	if (!b_connect->value()) {
		if (!connected) return;
		con->close();
		if_disconn();
		connected = 0; b_connect->clear();
	}
	else {
		if (connected) return; char *password = (options->password) ? (char *)NULL : (char *)"";
		try {
			if (options->password) {
				if (pass) password = pass; else	password = (char *)fl_password("Enter your password :","");
			}
			if (password)
				con->real_connect("",options->hostname.c_str(),options->username.c_str(),password,options->port,options->compress,options->int_timeout,options->socketname.c_str(),0);
			else {connected = 0; con->close(); if_disconn(); b_connect->clear(); s_fl_message(""); return;}
			s_fl_message("");
		} catch (BadQuery er) {
			s_fl_alert (er.error.c_str());  s_fl_alert("\n");
			connected = 0; if_disconn(); b_connect->clear();
			return;
		}
		connected = 1; if_conn(); if (connected) {b_connect->set(); if (con->connected() && !pass && password) pass = password;}
	}
}

void do_select_base (Fl_Choice  *w, void *p) {  
  Fl_Menu_*mw = (Fl_Menu_*)w;
  const Fl_Menu_Item *m = mw->mvalue();
  if (!m) return;
	try {
		tables.clear();   chosen_tables.clear();
		con->select_db((ldb =(char *) m->label())); 
		Query query = con->query();
		Result::iterator i; unsigned int counter;  
		query << "show tables";  Result result = query.store();
		for (i = result.begin(); i != result.end(); i++) {
			Row row = *i;	string xx(row[0]);
			tables.insert(tables.end(),xx);
		}
		num_of_tables=tables.size(); 		sql_command->cut(0,sql_command->size()); if (ldb) {ddd=(string)ldb; ldb=(char*)ddd.c_str();}
		pomocna_polja(); 
		qSortHelp (0, (size_t) queries.size(), Fcmp_q, Exchange_q);
		query_browser->clear(); for(counter=0;counter<queries.size() && queries[counter].db != (string)ldb;counter++);
		for (;counter<queries.size() && queries[counter].db == (string)ldb;query_browser->add(queries[counter].query.c_str()),counter++);
		s_fl_message("\nFound %d tables",tables.size());
  } catch (BadQuery er) {
    s_fl_alert (er.error.c_str());  s_fl_alert("\n"); s_fl_alert("There are corrupt tables\n or no tables in your database\n or you do not have rights in db %s !\n",ldb);
		sql_command->cut(0,sql_command->size());con->close(); connected = 0; if_disconn();  ldb = 0;
    return;
  }
}

void insert_command (Fl_Widget  *w, void *p) {  
  Fl_Menu_*mw = (Fl_Menu_*)w;
  const Fl_Menu_Item *m = mw->mvalue();
  if (!m) return;
	const char *s=sql_command->value(); if (s[0]) sql_command->insert(" ");
  sql_command->insert(m->label()); sql_command->insert(" "); sql_command->mark(sql_command->position());
}

void save_query(Fl_Button *ssw,void *ssp) {
	char Ime[256]; Ime[0]=0;
	int i = fl_file_dialog("Save Query",Ime,Fl_File_Dialog::SAVEMODE | Fl_File_Dialog::MESSAGES,0,0); if (!i) { s_fl_message("You gave up!"); return;} Trim(Ime);
	if (!Ime[0] || filename_isdir(Ime)) {s_fl_alert("You have to supply file name !!!!!!!\n"); return;}
	if (strcmp(filename_ext(Ime),".sql")) filename_setext(Ime,".sql");
	string dir(Ime), query(sql_command->value()); strip(query); strip(dir);
	if (!query.length()) {s_fl_alert("We do not save empty queries !!!!!!!\n"); return;}
#ifdef _WIN32
  FILE *fd = fopen(dir.c_str(),"w+");
  if (fd) {
    (void) fprintf(fd,query.c_str());
    (void) fclose(fd);
  }
  else
    s_fl_alert ("You have no rights to open  file %s for saving this query !!\n",dir.c_str());  
#else
	ofstream Out(dir.c_str(),ios::out | ios::trunc);
  if (!(Out.rdbuf())->is_open())
    s_fl_alert ("You have no rights to open  file %s for saving this query !!\n",dir.c_str());
  else {
    try {
      Out << query << "";
    } catch (...) {
      s_fl_alert ("Your file %s for saving this  query is damaged !!!\n",dir.c_str()); 
    }
  }	
#endif  
}

void make_menu(void) {
	if (polja) { for(int i=0;polja[i].text;i++) {if (polja[i].text) free((char *)(polja[i].text));}  free(polja); }
	polja = (Fl_Menu_Item *) malloc(sizeof(Fl_Menu_Item)*(num_of_tables*FIELDS_PER_TABLE)); 
	memset(polja,0,sizeof(Fl_Menu_Item)*(num_of_tables*FIELDS_PER_TABLE)); int kk=0;
	try {
		for (unsigned int j=0; j < num_of_tables;j++) {
			if (chosen_tables[j]) {
				Query query = con->query();
				query << "describe " << tables[j] << "";
				Result result = query.store(); Result::iterator i;
				for (i = result.begin(); i!=result.end();i++) {
					Row row = *i; string xx(tables[j]); strip(xx); 
					string yy(row[0]); strip(yy);
					xx += (string)"." + yy; for (unsigned int ii=0;ii<xx.length();xx[ii]=tolower(xx[ii]),ii++);
				  polja[kk].text=strdup(xx.c_str()); ++kk;
					if ((num_of_tables*FIELDS_PER_TABLE)-1 == kk) break;
				}
				if ((num_of_tables*FIELDS_PER_TABLE)-1 == kk) break;
			}
		}
		fie->menu(polja); s_fl_message("\nFound %d columns in %d tables",kk,num_of_tables);
  } catch (BadQuery er) {
    s_fl_alert (er.error.c_str());  s_fl_alert("\n");
    if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
      con->close(); sql_command->cut(0,sql_command->size());     connected = 0; if_disconn();
    }
    return;
  }
}

static void free_recurse(Fl_Menu_Item *ord_menu) {
	Fl_Menu_Item *p=ord_menu;
	while (p->text) {
		if (p->flags) {
			void *qq=p->user_data_;
			Fl_Menu_Item *q=(Fl_Menu_Item *)qq;
			free_recurse(q);
		}
		p++;
	}
  free(ord_menu); ord_menu=(Fl_Menu_Item *)0;
}

void ref_cache_m(Fl_Menu_*,void*) {if_conn();}
void ref_hier_m(Fl_Menu_*,void*) {
	if (options->q_root == (string)"") return; 
	hier->flags=0; hier->user_data_=NULL;  hier->deactivate(); Fl_Cursor cursor = Fl_Cursor(FL_CURSOR_WAIT); fl_cursor(cursor);

	if (query_menus) {
		free_recurse(query_menus);hierarchy.clear(); stringovi.clear(); query_menus=(Fl_Menu_Item *)0;
	}
	if (!access(options->q_root.c_str(),R_OK|X_OK))
		recurse (options->q_root,&query_menus);
	if (query_menus) { hier->activate(); hier->flags=FL_SUBMENU_POINTER; hier->user_data_=(void *)query_menus;} else hier->deactivate();
	cursor = Fl_Cursor(FL_CURSOR_DEFAULT); fl_cursor(cursor);
}

extern void get_vars (int *i); extern void bbbb(void);   vector<var_type> vars; 
void get_results(Fl_Button *, void *) { 
  string sql(sql_command->value()); string counts; unsigned int i, gde=0; int min;
  strip(sql); int total_var_size=0,total_value_size=0,offset=0; Fl::focus(sql_command); sql_command->cut(0,sql_command->size()); sql_command->value(sql.c_str()); sql_command->position(0); sql_command->mark(0); 
	var_type var; vars.clear();
  if (sql.length() < 5) {
    s_fl_message("Your query is too short !!\n"); return;
  }
	enum result_options kuda = (b_screen->value()) ? TO_SCREEN : ((b_file->value()) ? TO_FILE : TO_COUNT);
	if (strncasecmp(sql.c_str(),"SELECT",6) && (kuda == TO_COUNT)) {s_fl_alert("Count error !"); return;}
  for (i = 0; i < sql.length();i++) {
    int j=(int)  ((unsigned char)sql[i]); if ( j < 32) sql[i] = ' ';
	}
  Query query = con->query();
	int which_way = strncasecmp(sql.c_str(),"SELECT",6) && strncasecmp(sql.c_str(),"SHOW",4) && strncasecmp(sql.c_str(),"DESCRIBE",8)  && strncasecmp(sql.c_str(),"EXPLAIN",6);
	real_sql=sql;
	int where=real_sql.find("?");
	if (where>1) {
		int first = where+1, last=0;
		while (1) {
			if (!is_it_in_string(real_sql,first-1)) {
				last = real_sql.find("?",first);  
		error:
				if (last == -1) {
					string er("Parse error at '"); string pomocni(real_sql,first-1); sql_command->position(first-1); sql_command->mark(first-1);
					er += pomocni + "'"; s_fl_alert(er.c_str()); return;
				}
				var.name.assign(real_sql,(size_t)first,(size_t)(last-first)); strip(var.name); var.begin=first -1; var.end=last+1;
				var.value = (string)""; vars.insert(vars.end(),var); total_var_size += var.end - var.begin;
				if (var.name.find(" ") != -1) {last = -1; goto error;} 
				last++; if (last==real_sql.size()-1) break;
			}
			else last = first + 1;
			first = real_sql.find("?",last); if (first==-1) break;   first++;
		}
		if (vars.size()) {
			get_vars(&total_value_size);
			if (!total_value_size) {string er("You gave up!!\n"); s_fl_alert(er.c_str()); return;}
			for (unsigned int i=0;i<vars.size();i++) {
				var=vars[i]; real_sql.replace(var.begin+offset,var.end - var.begin,var.value); 
				offset += var.value.size() - (var.end - var.begin);
			}
		}
	}
  try {
    if (which_way) {
      query.execute(real_sql.c_str());
			s_fl_message(con->info().c_str()); s_fl_message("\n");
    }  else {
			if (!strncasecmp(real_sql.c_str(),"SELECT",6)) {
				string xx(real_sql); unsigned int ii;
				for (ii=0;ii<xx.length();xx[ii]=tolower(xx[ii]),ii++);
				if (kuda==TO_COUNT) {
					ii = xx.find(" from "); while ((ii != -1) && is_it_in_string(xx,ii-1)) ii = xx.find(" from ",++ii);
					if (ii == -1) {s_fl_alert("Parse error"); return;}
					real_sql = (string)"SELECT COUNT(*)  " + real_sql.erase(0,ii);
				} else if (commands27->value()) {
					ii=xx.find(" limit "); while ((ii != -1) && is_it_in_string(xx,ii-1)) ii = xx.find(" limit ",++ii);
					if (ii == -1) {
						int rows=int(limit->value()); char buf[13]; sprintf(buf,"%d",rows);
						real_sql += (string)" LIMIT " + (string)buf;
					}
				}
			}
      query << real_sql; Fl_Cursor cursor = Fl_Cursor(FL_CURSOR_WAIT); fl_cursor(cursor);
			Result result = query.store();
			num_of_rows = result.size(); cursor = Fl_Cursor(FL_CURSOR_DEFAULT); fl_cursor(cursor);
			if (!result.size() || !result.num_fields()) {
				s_fl_message("Your query produced no results !\n"); return;
			}  
			if ((kuda==TO_COUNT) && !strncasecmp(real_sql.c_str(),"SELECT",6)) {
				Result::iterator iter = result.begin(); Row row = *iter; counts=row[0]; 
			}
		}
  } catch (BadQuery er) {
		Fl_Cursor cursor = Fl_Cursor(FL_CURSOR_DEFAULT); fl_cursor(cursor);
    if ((con->errnum() && (con->errnum()!=1065))) {
			s_fl_alert(er.error.c_str()); s_fl_alert("\n");  
			if ((kuda != TO_COUNT) && (con->errnum() == 1064)) { 
				string str = er.error.erase(0,er.error.find("\'")+1); str = str.erase(str.find("\'"),-1);
				int ii = real_sql.find(str); offset = 0;
				if (ii != -1) {
					if (total_value_size && total_var_size) {
						for (unsigned int i=0;i<vars.size();i++) {
							var=vars[i]; if (ii >= var.begin) offset += var.value.size() - (var.end - var.begin);
						}
					}
					sql_command->position(ii + offset); sql_command->mark(ii + offset);
				}
			}
			if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
				con->close(); connected = 0; if_disconn(); sql_command->cut(0,sql_command->size()); 
			}
			return;
    }
		else s_fl_message("Command has successfully executed\n");
		if (con->errnum() == 1065) {
			if (!strncasecmp(real_sql.c_str(),"USE",3)) {
				unsigned int j; string database(real_sql,4); strip(database);
				for (j=0;j<databases.size();j++) {
					if (!strcasecmp(databases[j].c_str(),database.c_str()))
						break;
				}
				if (j<databases.size()) { 
					Fl::focus(choice_db);
					choice_db->value(j); choice_db->label(databases[j].c_str()); choice_db->redraw();
					Fl::focus(sql_command); 
				}
			}
		}
	}
	if (!which_way) {
		switch (kuda) {
		case TO_SCREEN: if (commands29->value()) editing_stuff(real_sql.c_str()); else do_sql(); s_fl_message(con->info().c_str()); s_fl_message("\n"); break;
		case TO_FILE:  {i = fl_file_dialog("Save Results",file_name,Fl_File_Dialog::APPEND | Fl_File_Dialog::SAVEMODE | Fl_File_Dialog::MESSAGES,0,0);  if (!file_name[0] || !i)  break; 
			how_to_open=(i>1000) ? ios::app : ios::trunc;
			if (strcmp(filename_ext(file_name),".res")) filename_setext(file_name,".res");  
      Fl_Cursor cursor = Fl_Cursor(FL_CURSOR_WAIT); fl_cursor(cursor); do_save_file(real_sql); cursor = Fl_Cursor(FL_CURSOR_DEFAULT); fl_cursor(cursor);
			s_fl_message(con->info().c_str()); } break;
		case TO_COUNT: s_fl_message("Number of rows = %s",counts.c_str()); break;
		default : exit(111);
		}
	}
	Fl::focus(sql_command); 
	if (!con->errnum() || (con->errnum()==1065)) {
		int i;
		if ((where_in_queries == INT_MAX)  || (sql != queries[where_in_queries].query))  {
			if (queries.size() >= (unsigned int)options->int_queries) { 
				for (i=0,min=1000000;i<queries.size();i++) {
					if (queries[i].redosled<min) {
						min=queries[i].redosled; gde=i;
					}
          queries[i].redosled--;
				}  
				if ((string)ldb == queries[gde].db) { 
					for(i=0;i<query_browser->size();i++) {
						if (!strcmp(queries[gde].query.c_str(),query_browser->text(i+1))) break;
					}
					if (i<query_browser->size()) query_browser->remove(i+1); 
				}
				store_query *st=&(queries[gde]); queries.erase(st);
			}
		}
		if (which_way || (kuda!=TO_COUNT)) {
			for (i=1;i<=query_browser->size();i++) {
				string s(query_browser->text(i));
				if (s==sql) break;
			}
			if (i>query_browser->size()) {
				string ddd(ldb); store_query st(ddd,sql,queries.size()); queries.insert(queries.end(),st); 
			}
			else 
				query_browser->remove(i); 
			query_browser->add(sql.c_str());  query_browser->redraw();  query_browser->activate();
			if (!con->info().length() && (!which_way) && (kuda==TO_SCREEN)) output->cut(0,output->size());
		}
		query_browser->select(query_browser->size()); 
	}
  return;
}

void database_func  (int drop, const char *koja) {
	string id1(koja); strip(id1); string id("CREATE DATABASE "); if (drop) id = (string) "DROP DATABASE "; id += id1; if (!connected) return;
	Connection con(use_exceptions);
	try {
		con.real_connect ("",options->hostname.c_str(),options->username.c_str(),\
											(pass) ? pass : "",options->port,options->compress,options->int_timeout,options->socketname.c_str(),0);
		Query query = con.query();  
		query.execute(id.c_str());
		adm_ispis = 1; s_fl_message(con.info().c_str()); adm_ispis = 1; s_fl_message("database %s succeeded\n",(drop) ? "DROP" : "CREATE");
		if_conn();
	} catch (BadQuery er){
		adm_ispis = 1; s_fl_alert("Error in database function: %s %d ",er.error.c_str(), con.errnum()); return;
	}	
}

void do_save_file (string& sql) { 
	unsigned int columns, counter, num_of_rows; vector<string> field_names; vector<int> field_lengths;
	char terminator[11]; strcpy (terminator,options->terminator.c_str()); char enclose[11]; strcpy(enclose,options->enclose.c_str());
	if (!strcmp(terminator,"<TAB>")) strcpy (terminator,"\t"); if (strstr(enclose,"nothing")) strcpy (enclose,"");
	if (access(file_name,R_OK|W_OK)) how_to_open=ios::trunc;
#ifdef _WIN32
//  int handle = open(file_name,(how_to_open == ios::trunc) ? O_WRONLY | O_TRUNC : O_WRONLY | O_APPEND);
  FILE  *fd = fopen(file_name,"w+");
  if (fd) {
    try {
      Query query = con->query();
      query << sql;  Result result = query.store(); num_of_rows=result.size();  Result::iterator i;   Row row; terminator[1] = '\0';
      vector <int> field_types; vector <string> field_names;
      MYSQL_RES *ress= result.mysql_result(); columns = result.num_fields();
      for  (counter=0;counter<columns;counter++) {
        MYSQL_FIELD  *field = mysql_fetch_field_direct(ress,counter);
        switch (field->type) {
        case  FIELD_TYPE_TINY:
        case  FIELD_TYPE_SHORT:  
        case  FIELD_TYPE_LONG:
        case  FIELD_TYPE_LONGLONG:
        case  FIELD_TYPE_INT24: field_types.insert(field_types.end(),0); break;
        case  FIELD_TYPE_FLOAT:
        case  FIELD_TYPE_DOUBLE: field_types.insert(field_types.end(),1);  break;
        case  FIELD_TYPE_DECIMAL:
        case  FIELD_TYPE_TIMESTAMP:
        case  FIELD_TYPE_DATE:
        case  FIELD_TYPE_TIME:
        case  FIELD_TYPE_DATETIME:
        case  FIELD_TYPE_YEAR:
        case  FIELD_TYPE_NEWDATE:
        case  FIELD_TYPE_VAR_STRING:
        case  FIELD_TYPE_NULL: 
        case  FIELD_TYPE_STRING: field_types.insert(field_types.end(),2);  break;
        case  FIELD_TYPE_ENUM:
        case  FIELD_TYPE_SET:  field_types.insert(field_types.end(),3); break;
        case  FIELD_TYPE_TINY_BLOB:
        case  FIELD_TYPE_MEDIUM_BLOB:
        case  FIELD_TYPE_LONG_BLOB:
        case  FIELD_TYPE_BLOB:
        default : field_types.insert(field_types.end(),4); break;
        }
        int length = field->max_length;  if (field_types[counter]> 1) length+=2;  
        char buffer [101]; strcpy(buffer,field->name); if (strlen(buffer) > length) length = strlen(buffer); 
        field_names.insert(field_names.end(),(string)buffer); field_lengths.insert(field_lengths.end(),length);
      }
      ress = result.mysql_result(); MYSQL_ROW roww;
      if (how_to_open==ios::trunc) {
        (void) fprintf(fd,"#   %s\n\n# ",sql.c_str());
        for (int j=0;j<columns;j++) {
          char *s = (counter < columns -1 ) ? terminator : (char *) " ";
          (void) fprintf(fd,"%*s%s",field_lengths[j],field_names[j].c_str(),s);
        }
        (void) fprintf(fd,"\n\n");
      }
      for (i = result.begin(); i!=result.end();i++) {
        /*row = *i; */ roww = mysql_fetch_row(ress); if (!roww) break;
        for (counter = 0; counter < columns;counter++) {
          if (roww[counter]==NULL) roww[counter]="";
          char *s = (counter < columns -1 ) ? terminator : (char *) " ";
          if (field_types[counter] < 2)
            (void) fprintf(fd,"%*s%s",field_lengths[counter],roww[counter],s);            
          else {
            Trim(roww[counter]); string xx(field_lengths[counter]-strlen(roww[counter]),' ');
            (void) fprintf(fd,"%s%*s%s%s%s",enclose,field_lengths[counter],roww[counter],enclose,xx.c_str(),s);            
          }
        }
        fprintf(fd,"\n");
      }
       s_fl_message("\nFile %s saved",file_name);
    }
    catch (BadQuery er) { 
      s_fl_alert(er.error.c_str()); s_fl_alert("\n");
      if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
        con->close(); connected = 0; if_disconn();
      }
      return;
    } catch (BadConversion er) {
      ostrstream strbuf;
      strbuf  << "Error: Tried to convert \"" << er.data << "\" to a \"" << er.type_name << "\"." << endl;
      s_fl_alert(strbuf.str()); return ;
    }
    (void) fclose(fd);
  }
  else
    s_fl_alert ("You have no rights to open text file %s for saving this query !!\n",file_name);  
#else
	ofstream Out(file_name,ios::out | how_to_open);
	if (!(Out.rdbuf())->is_open())
		s_fl_alert ("You have no rights to open text file %s for writing !!\n",file_name);
	else {
		try {
			Query query = con->query();
			query << sql;  Result result = query.store(); num_of_rows=result.size(); 	Result::iterator i;   Row row; terminator[1] = '\0';
			vector <int> field_types; vector <string> field_names;
			MYSQL_RES *ress= result.mysql_result(); columns = result.num_fields();
			for  (counter=0;counter<columns;counter++) {
				MYSQL_FIELD  *field = mysql_fetch_field_direct(ress,counter);
				switch (field->type) {
				case	FIELD_TYPE_TINY:
				case	FIELD_TYPE_SHORT:  
				case  FIELD_TYPE_LONG:
				case	FIELD_TYPE_LONGLONG:
				case  FIELD_TYPE_INT24: field_types.insert(field_types.end(),0); break;
				case 	FIELD_TYPE_FLOAT:
				case  FIELD_TYPE_DOUBLE: field_types.insert(field_types.end(),1);  break;
				case  FIELD_TYPE_DECIMAL:
				case  FIELD_TYPE_TIMESTAMP:
				case  FIELD_TYPE_DATE:
				case  FIELD_TYPE_TIME:
				case  FIELD_TYPE_DATETIME:
				case  FIELD_TYPE_YEAR:
				case  FIELD_TYPE_NEWDATE:
				case  FIELD_TYPE_VAR_STRING:
				case	FIELD_TYPE_NULL: 
				case  FIELD_TYPE_STRING: field_types.insert(field_types.end(),2);  break;
				case	FIELD_TYPE_ENUM:
				case  FIELD_TYPE_SET:  field_types.insert(field_types.end(),3); break;
				case  FIELD_TYPE_TINY_BLOB:
				case  FIELD_TYPE_MEDIUM_BLOB:
				case  FIELD_TYPE_LONG_BLOB:
				case  FIELD_TYPE_BLOB:
				default : field_types.insert(field_types.end(),4); break;
				}
				unsigned int length = field->max_length;  if (field_types[counter]> 1) length+=2;  
				char buffer [101]; strcpy(buffer,field->name);	if (strlen(buffer) > length) length = strlen(buffer); 
				field_names.insert(field_names.end(),(string)buffer); field_lengths.insert(field_lengths.end(),length);
			}
			ress = result.mysql_result(); MYSQL_ROW roww;
			if (how_to_open==ios::trunc) {
				Out << "#   " << sql << endl << endl << "# "; Out.setf(ios::left);
				for (unsigned int j=0;j<columns;j++) {
					char *s = (counter < columns -1 ) ? terminator : (char *) " ";
					Out << setw(field_lengths[j]) << field_names[j] << s;
				}
				Out << endl << endl;
			}
			for (i = result.begin(); i!=result.end();i++) {
				/*row = *i; */ roww = mysql_fetch_row(ress); if (!roww) break;
				for (counter = 0; counter < columns;counter++) {
					if (roww[counter]==NULL) roww[counter]="";
					char *s = (counter < columns -1 ) ? terminator : (char *) " "; Out.setf(ios::left);
					if (field_types[counter] < 2)
						Out << setw(field_lengths[counter]) <<  roww[counter] <<  s;
					else {
						Trim(roww[counter]); string xx(field_lengths[counter]-strlen(roww[counter]),' ');
						Out << enclose << escape << roww[counter] << enclose << xx << s;
					}
				}
				Out << endl;
			}
			s_fl_message("\nFile %s saved",file_name);
		}
		catch (BadQuery er) { 
			s_fl_alert(er.error.c_str()); s_fl_alert("\n");
			if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
				con->close(); connected = 0; if_disconn();
			}
			return;
		} catch (BadConversion er) {
			ostrstream strbuf;
			strbuf  << "Error: Tried to convert \"" << er.data << "\" to a \"" << er.type_name << "\"." << endl;
			s_fl_alert(strbuf.str()); return ;
		}
		s_fl_message("All %d rows from your result set are saved in %s\n",num_of_rows,file_name);
	}
#endif  
}

void do_exit (Fl_Widget *wwww, void *pppp) {
	if (!options->ask) {if (!fl_ask("Are you sure you want to exit ?")) return;}
	if (queries.size()) {
  qSortHelp (0, (size_t) queries.size(), Fcmp_qq, Exchange_q);    
#ifdef _WIN32
//  int handle = open(queries_file_name.c_str(),O_WRONLY | O_TRUNC);
  FILE *fd = fopen (queries_file_name.c_str(),"w+");
  if (fd) {
    for (unsigned int i = 0; i < queries.size();i++) {
      if (queries[i].db.length())
        fprintf(fd,"use  %s ; %s ;\n", queries[i].db.c_str(),queries[i].query.c_str());
      else
        fprintf(fd,"%s ;\n",queries[i].query.c_str());
    }
    (void) fclose(fd);
  }
  else
    s_fl_alert ("Your history  file %s is damaged !!!",queries_file_name.c_str()); 
#else
		ofstream Out(queries_file_name.c_str(),ios::out | ios::trunc);
		if (!(Out.rdbuf())->is_open())
			s_fl_alert ("You have no rights to open history file %s for writing !!",queries_file_name.c_str());
		else {
			try {
				for (unsigned int i = 0; i < queries.size();i++) {
					if (queries[i].db.length())
						Out <<  "use " << queries[i].db << " ; " << queries[i].query << ";" << endl;
					else
						Out << queries[i].query << ";" << endl;
				}
			} catch (...) {
				s_fl_alert ("Your history  file %s is damaged !!!",queries_file_name.c_str()); 
			}
		}
#endif    
	}
	if (options->l_d_file.length() && ldb) {
#ifdef _WIN32    
//  int handle = open(options->l_d_file.c_str(),O_WRONLY | O_TRUNC);
  FILE *fd = fopen (options->l_d_file.c_str(),"w+");
  if (fd) {
    (void) fprintf(fd,"%s ; %d ; %d",ldb,main_window->x(),main_window->y());
    (void) fclose(fd);
  }
  else
    s_fl_alert ("Your database save file %s is damaged !!!",options->l_d_file.c_str()); 
#else
		ofstream Out(options->l_d_file.c_str(),ios::out | ios::trunc);
		if (!(Out.rdbuf())->is_open())
			s_fl_alert ("You have no rights to open ^ database save file %s for writing !!",options->l_d_file.c_str());
		else {
			try {
				Out << ldb << " ; " << main_window->x() << " ; " << main_window->y() << " ; " ;
			} catch (...) {
				s_fl_alert ("Your database save file %s is damaged !!!",options->l_d_file.c_str()); 
			}
		}
#endif    
	}
	if (connected) con->close(); // Fl_Window* w = Fl::first_window();
	while (Fl::first_window()) Fl::first_window()->hide();
//	while (w) {Fl_Window *x = Fl::next_window(w); if (w && !w->modal()) delete w; w=x;}
}

#ifdef __WIN32__
FL_EXPORT int main(int argc, char *argv[]) {
#else
int main (void) {
#endif  
  do_splash(); Fl::focus(splash); for (int i=0;i<koliko;i++) {Fl::wait(); Fl_Widget *o=Fl::readqueue();}
	c_info=s_info=(string)"Unknown"; splash->position(main_x,main_y);
	con = new Connection(use_exceptions); init_code(); 
  if (options->username.length()) {
    try {
      char *password = (options->password) ? (char *)NULL : (char *)"";
      if (options->password){
				if (pass) password = pass; else password = (char *)fl_password("Enter your password :","");
			}
      if (password) { 
        con->real_connect("",options->hostname.c_str(),options->username.c_str(),\
                        password,options->port,options->compress,options->int_timeout,options->socketname.c_str(),0);
				        connected = 1; if (con->connected() && !pass && password) pass = password;
      }
      else connected = 0;
    } catch (BadQuery er) {
      s_fl_alert (er.error.c_str());
      connected = 0; 
			if ((con->errnum() > 2000) || (con->errnum() == 1043)) {
				con->close(); connected = 0;
			}
    }
  }
  init_window(); main_window->position(main_x,main_y);
	main_window->show(); options_window=(Fl_Window *)NULL;
	if (connected) if_conn(); else if_disconn(); if (!queries.size()) query_browser->deactivate(); bbbb();
	if (!help_file_name.length()) {help1->deactivate(); b_help->deactivate();} splash->hide(); delete splash;
	return Fl::run();
}
